/*
   for C++
   misc.cc
   */


#include "misc.h"
#include <ctype.h>
#include <string.h>


char *strtolower(char *str)
     // ʸʸѴ
{
  if (str)
  {
    char *s=str;
    while(*s)
    {
      if (isupper(*s)) *s=tolower(*s);
      s++;
    }
  }
  return str;
}


char *strtoupper(char *str)
     // ʸʸѴ
{
  if (str)
  {
    char *s=str;
    while(*s)
    {
      if (islower(*s)) *s=toupper(*s);
      s++;
    }
  }
  return str;
}


char *ntolower_string(char *str, int size)
     // ʸʸѴ
{
  if (str)
  {
    char *s=str;
    while(*s && size>0)
    {
      if (isupper(*s)) *s=tolower(*s);
      s++;
      size--;
    }
  }
  return str;
}


char *ncopy_string(char *dest_str, const int dest_size, const char *src_str)
{
  if (dest_str && dest_size>0 && src_str)
  {
    char *d=dest_str;
    char *dest_end=dest_str+dest_size-1;
    while(*src_str && d!=dest_end) *(d++)=*(src_str++);
    *d='\0';
  }
  return dest_str;
}


char *ncat_string(char *dest_str, const int dest_size, const char *src_str)
{
  if (dest_str && dest_size>0 && src_str)
  {
    int dest_len=nlen_string(dest_str, dest_size);
    if (dest_size<=dest_len+1) return dest_str;
    char *d=dest_str+dest_len;
    char *dest_end=dest_str+dest_size-1;
    while(*src_str && d!=dest_end) *(d++)=*(src_str++);
    *d='\0';
  }
  return dest_str;
}


#define _UL_FIGURES_ 10

char *ULto_string(UL n)
{
  static char buf[_UL_FIGURES_+1];
  char *b=buf;
  do {
    *(b++)=n%10+'0';
    n/=10;
  } while(n || b==buf+_UL_FIGURES_);
  *b='\0';
  int len=int(b-buf)/2;
  b--;
  for (int i=0; i<len; i++, b--)
  {
    char t=*b;
    *b=buf[i];
    buf[i]=t;
  }
  return buf;
}


int ncreate_multi_string(char *dest_mstr, const int dest_size, const char * const *src_str, const int src_n)
     // dest_mstr="src_str0\nsrc_str1\nsrc_str2\n..." Ȥʤ
     // return dest_mstr Ĺ
{
  int d_size=0;
  if (dest_mstr && dest_size>0)
    for (int i=0; i<src_n; i++)
    {
      if (src_str[i])
      {
	ncpy_string(dest_mstr+d_size, dest_size-d_size, src_str[i]);
	d_size+=strlen(dest_mstr+d_size)+1;
	if (d_size>=dest_size) break;
      }
    }
  return d_size;
}


int nseparate_multi_string(const char **dest_str, const int dest_n, const char *src_mstr, int src_size)
     // return separate Ǥ
{
  if (!dest_str || dest_n<=0 || !src_mstr || src_size<0) return 0;
  int i;
  for (i=0; i<dest_n; i++)
  {
    dest_str[i]=src_mstr;
    int len=nlen_string(src_mstr, src_size)+1;
    src_mstr+=len;
    src_size-=len;
    if (src_size<=0 || len==0) break;
  }
  return i;
}


int nlengh_string(const char *str, const int size)
{
  if (!str || size<=0) return -1;
  int len=0;
  while(*str)
  {
    str++;
    len++;
    if (size==len) return -1;
  }
  return len;
}
